Data elements endpoint
A data element functions as a variable which points to an important piece of data within your application. Data elements are used within rules and extension configurations. When a rule is triggered at runtime in a browser or an application, the value of the data element is resolved and used within the rule. Data elements function the same for extension configurations.
Using several data elements together results in a data dictionary or data map. This dictionary represents the data that Adobe Experience Platform knows about and can make use of.
A data element belongs to exactly one property. A property can have many data elements.
For more general information on data elements and their use in tags, see the data elements guide in the UI documentation.
Getting started
The endpoint used in this guide is part of the Reactor API. Before continuing, please review the getting started guide for important information regarding how to authenticate to the API.
Retrieve a list of data elements list
You can retrieve a list of data elements for a property by including the property’s ID in the path of a GET request.
API format
GET /properties/{PROPERTY_ID}/data_elements
PROPERTY_IDid of the property that owns the data elements.created_atdirtyenablednameorigin_idpublishedpublished_atrevision_numberupdated_at
Request
curl -X GET \
https://reactor.adobe.io/properties/PR97d92a379a5f48758947cdf44f607a0d/data_elements \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns a list of data elements for the specified property.
{
"data": [
{
"id": "DE5d11b3ed301d4ce99b530a5121e392b2",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:36:09.045Z",
"deleted_at": null,
"dirty": true,
"enabled": true,
"name": "My Data Element 2020-12-14 17:36:08 +0000",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:36:09.045Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementProperty\":\"html\",\"elementSelector\":\".target-element\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/property"
},
"data": {
"id": "PR97d92a379a5f48758947cdf44f607a0d",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/origin"
},
"data": {
"id": "DE5d11b3ed301d4ce99b530a5121e392b2",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/extension"
},
"data": {
"id": "EX0348d463358c4c89afe726245576f112",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2/updated_with_extension"
},
"data": {
"id": "EX1cc78b39339242da82a0e0752fa53375",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR97d92a379a5f48758947cdf44f607a0d",
"origin": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2",
"self": "https://reactor.adobe.io/data_elements/DE5d11b3ed301d4ce99b530a5121e392b2",
"extension": "https://reactor.adobe.io/extensions/EX0348d463358c4c89afe726245576f112"
},
"meta": {
"latest_revision_number": 0
}
}
],
"meta": {
"pagination": {
"current_page": 1,
"next_page": null,
"prev_page": null,
"total_pages": 1,
"total_count": 1
}
}
}
Look up a data element lookup
You can look up a data element by providing its ID in the path of a GET request.
data.meta.deleted_at attribute.API format
GET /data_elements/{DATA_ELEMENT_ID}
DATA_ELEMENT_IDid of the data element that you want to look up.Request
curl -X GET \
https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833 \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns the details of the data element.
{
"data": {
"id": "DE8097636264104451ac3a18c95d5ff833",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:35:54.956Z",
"deleted_at": null,
"dirty": true,
"enabled": true,
"name": "My Data Element 2020-12-14 17:35:54 +0000",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:35:54.956Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementProperty\":\"html\",\"elementSelector\":\".target-element\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/property"
},
"data": {
"id": "PRa5621686159f44c880557e12af412a95",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/origin"
},
"data": {
"id": "DE8097636264104451ac3a18c95d5ff833",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/extension"
},
"data": {
"id": "EX085a465793b54be39b5408d13b50b46e",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833/updated_with_extension"
},
"data": {
"id": "EXf9a32699efde42e9b9410b43bd660848",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PRa5621686159f44c880557e12af412a95",
"origin": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833",
"self": "https://reactor.adobe.io/data_elements/DE8097636264104451ac3a18c95d5ff833",
"extension": "https://reactor.adobe.io/extensions/EX085a465793b54be39b5408d13b50b46e"
},
"meta": {
"latest_revision_number": 0
}
}
}
Create a data element create
You can create a new data element by making a POST request.
API format
POST /properties/{PROPERTY_ID}/data_elements
PROPERTY_IDid of the property that you are defining the data element under.Request
The following request creates a new data element for the specified property. The call also associates the data element with an existing extension through the relationships property. See the guide on relationships for more information.
curl -X POST \
https://reactor.adobe.io/properties/PR97d92a379a5f48758947cdf44f607a0d/data_elements \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H 'Content-Type: application/json' \
-d '{
"data": {
"attributes": {
"name": "My Data Element 2020-12-14 17:33:21 +0000",
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"settings": "{\"elementSelector\":\".target-element\",\"elementProperty\":\"html\"}",
"default_value": "general_label",
"enabled": true,
"force_lower_case": true,
"clean_text": true,
},
"relationships": {
"extension": {
"data": {
"id": "EX28788723a8e24a2f927fce1b55eb7ffc",
"type": "extensions"
}
}
},
"type": "data_elements"
}
}'
attributes.nameattributes.delegate_descriptor_idattributes.settingsattributes.default_valueundefined.attributes.enabledattributes.force_lower_caseattributes.clean_texttypedata_elements.Response
A successful response return the details of the newly created data element.
{
"data": {
"id": "DE8667bc64ceba4b599e8458ea4ab58b8f",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:33:21.774Z",
"deleted_at": null,
"dirty": true,
"enabled": true,
"name": "My Data Element 2020-12-14 17:33:21 +0000",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:33:21.774Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementSelector\":\".target-element\",\"elementProperty\":\"html\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/property"
},
"data": {
"id": "PR05ad70a8078f44c1a229ecf0da2802f2",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/origin"
},
"data": {
"id": "DE8667bc64ceba4b599e8458ea4ab58b8f",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/extension"
},
"data": {
"id": "EX28788723a8e24a2f927fce1b55eb7ffc",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f/updated_with_extension"
},
"data": {
"id": "EXd6bf04b143e64fe0ae7efe55a6655fa9",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR05ad70a8078f44c1a229ecf0da2802f2",
"origin": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f",
"self": "https://reactor.adobe.io/data_elements/DE8667bc64ceba4b599e8458ea4ab58b8f",
"extension": "https://reactor.adobe.io/extensions/EX28788723a8e24a2f927fce1b55eb7ffc"
},
"meta": {
"latest_revision_number": 0
}
}
}
Update a data element update
You can update a data element by including its ID in the path of a PATCH request.
API format
PATCH /data_elements/{DATA_ELEMENT_ID}
DATA_ELEMENT_IDid of the data element that you want to update.Request
The following request updates the name for an existing data element.
curl -X PATCH \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H 'Content-Type: application/json' \
-d '{
"data": {
"attributes": {
"name": "New Data Element Name"
},
"id": "DE3fab176ccf8641838b3da59f716fc42b",
"type": "data_elements"
}
}'
attributesidid of the data element you want to update. This should match the {DATA_ELEMENT_ID} value provided in the request path.typedata_elements.Response
A successful response returns the details of the updated data element.
{
"data": {
"id": "DE3fab176ccf8641838b3da59f716fc42b",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:36:24.552Z",
"deleted_at": null,
"dirty": true,
"enabled": true,
"name": "New Data Element Name",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:36:25.578Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementSelector\":\".target-element-b\",\"elementProperty\":\"html\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/property"
},
"data": {
"id": "PR85e261fb61ce44c9b2498807a6e6410b",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/origin"
},
"data": {
"id": "DE3fab176ccf8641838b3da59f716fc42b",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/extension"
},
"data": {
"id": "EX71f31a3eeec249dfb77fedd6c5ce6387",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/updated_with_extension"
},
"data": {
"id": "EX1f4df32a850c48a4930fb3e1dfa83536",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR85e261fb61ce44c9b2498807a6e6410b",
"origin": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b",
"self": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b",
"extension": "https://reactor.adobe.io/extensions/EX71f31a3eeec249dfb77fedd6c5ce6387"
},
"meta": {
"latest_revision_number": 0
}
}
}
Revise a data element revise
When you revise a data element, a new revision of the data element is created with the current (head) revision. Each revision of a data element will have its own ID. The original data element may be discovered through an origin link.
You can revising a data element by supplying a meta.action property with a value of revise in the body of a PATCH request.
API format
PATCH /data_elements/{DATA_ELEMENT_ID}
DATA_ELEMENT_IDid of the data element that you want to revise.Request
curl -X PATCH \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H 'Content-Type: application/json' \
-d '{
"data": {
"attributes": {
"name": "New Data Element Name"
},
"meta": {
"action": "revise"
},
"id": "DE7d7284657ee540ee8f402277860e9f8a",
"type": "data_elements"
}
}'
attributesmeta.actionrevise, this property indicates that a new revision should be created for the data element.idid of the data element you want to revise. This should match the {DATA_ELEMENT_ID} value provided in the request path.typedata_elements.Response
A successful response returns the details of the new revision for the data element, as indicated by the incremented meta.latest_revision_number attribute.
{
"data": {
"id": "DE3fab176ccf8641838b3da59f716fc42b",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:36:24.552Z",
"deleted_at": null,
"dirty": true,
"enabled": true,
"name": "New Data Element Name",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:36:25.578Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementSelector\":\".target-element-b\",\"elementProperty\":\"html\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/property"
},
"data": {
"id": "PR85e261fb61ce44c9b2498807a6e6410b",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/origin"
},
"data": {
"id": "DE3fab176ccf8641838b3da59f716fc42b",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/extension"
},
"data": {
"id": "EX71f31a3eeec249dfb77fedd6c5ce6387",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/updated_with_extension"
},
"data": {
"id": "EX1f4df32a850c48a4930fb3e1dfa83536",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR85e261fb61ce44c9b2498807a6e6410b",
"origin": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b",
"self": "https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b",
"extension": "https://reactor.adobe.io/extensions/EX71f31a3eeec249dfb77fedd6c5ce6387"
},
"meta": {
"latest_revision_number": 1
}
}
}
Delete a data element
You can delete a data element by including its ID in the path of a DELETE request.
API format
DELETE /data_elements/{DATA_ELEMENT_ID}
DATA_ELEMENT_IDid of the data element that you want to delete.Request
curl -X DELETE \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}'
Response
A successful response returns HTTP status 204 (No Content) with no response body, indicating that the data element has been deleted.
Manage notes for a data element notes
Data elements are “notable” resources, meaning you can create and retrieve text-based notes on each individual resource. See the notes endpoint guide for more information on how to manage notes for data elements and other compatible resources.
Retrieve related resources for a data element related
The following calls demonstrate how to retrieve the related resources for a data element. When looking up a data element, these relationships are listed under the relationships property.
See the relationships guide for more information on relationships in the Reactor API.
List the related libraries for a data element libraries
You can list the libraries that utilize a data element by appending /libraries to the path of a lookup request.
API format
GET /data_elements/{DATA_ELEMENT_ID}/libraries
{DATA_ELEMENT_ID}id of the data element whose libraries you want to list.Request
curl -X GET \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/libraries \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns a list of libraries that use the specified data element.
{
"data": [
{
"id": "LB62d20ad807a949e6b13b0a2c7299eb65",
"type": "libraries",
"attributes": {
"created_at": "2020-12-14T17:50:19.589Z",
"name": "My Library",
"published_at": null,
"state": "development",
"updated_at": "2020-12-14T17:50:19.589Z",
"build_required": true
},
"relationships": {
"builds": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/builds"
}
},
"environment": {
"links": {
"self": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/relationships/environment"
},
"data": null
},
"data_elements": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/data_elements",
"self": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/relationships/data_elements"
}
},
"extensions": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/extensions",
"self": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/relationships/extensions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/notes"
}
},
"rules": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/rules",
"self": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/relationships/rules"
}
},
"upstream_library": {
"data": null
},
"property": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/property"
},
"data": {
"id": "PR241ba9cd56324ac192de68d658f20cb0",
"type": "properties"
}
},
"last_build": {
"links": {
"related": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65/last_build"
},
"data": null
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR241ba9cd56324ac192de68d658f20cb0",
"self": "https://reactor.adobe.io/libraries/LB62d20ad807a949e6b13b0a2c7299eb65"
},
"meta": {
"build_status": null,
"build_required_detail": "No build found since last state change"
}
}
],
"meta": {
"pagination": {
"current_page": 1,
"next_page": null,
"prev_page": null,
"total_pages": 1,
"total_count": 1
}
}
}
List the related revisions for a data element revisions
You can list the previous revisions of a data element by appending /revisions to the path of a lookup request.
API format
GET /data_elements/{DATA_ELEMENT_ID}/revisions
{DATA_ELEMENT_ID}id of the data element whose revisions you want to list.Request
curl -X GET \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/revisions \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns a list of revisions for the specified data element.
{
"data": [
{
"id": "DEaeceb5164d494c768c18e37ec6f3b091",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:37:06.488Z",
"deleted_at": null,
"dirty": false,
"enabled": true,
"name": "My Data Element 2020-12-14 17:37:05 +0000",
"published": false,
"published_at": null,
"revision_number": 1,
"updated_at": "2020-12-14T17:37:06.488Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementProperty\":\"html\",\"elementSelector\":\".target-element\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/property"
},
"data": {
"id": "PR52072581500b44cd808e03e36c38e005",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/origin"
},
"data": {
"id": "DE5172417ff56e43d2a99ca149021bf65a",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/extension"
},
"data": {
"id": "EXdd53073348ef467683365286a33ade02",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091/updated_with_extension"
},
"data": {
"id": "EXf9d7d1ca8e6f436b900659ce499c09ce",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR52072581500b44cd808e03e36c38e005",
"origin": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a",
"self": "https://reactor.adobe.io/data_elements/DEaeceb5164d494c768c18e37ec6f3b091",
"extension": "https://reactor.adobe.io/extensions/EXdd53073348ef467683365286a33ade02"
},
"meta": {
"latest_revision_number": 1
}
},
{
"id": "DE5172417ff56e43d2a99ca149021bf65a",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:37:05.920Z",
"deleted_at": null,
"dirty": false,
"enabled": true,
"name": "My Data Element 2020-12-14 17:37:05 +0000",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:37:05.920Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementProperty\":\"html\",\"elementSelector\":\".target-element\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/property"
},
"data": {
"id": "PR52072581500b44cd808e03e36c38e005",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/origin"
},
"data": {
"id": "DE5172417ff56e43d2a99ca149021bf65a",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/extension"
},
"data": {
"id": "EXdd53073348ef467683365286a33ade02",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a/updated_with_extension"
},
"data": {
"id": "EXf9d7d1ca8e6f436b900659ce499c09ce",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR52072581500b44cd808e03e36c38e005",
"origin": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a",
"self": "https://reactor.adobe.io/data_elements/DE5172417ff56e43d2a99ca149021bf65a",
"extension": "https://reactor.adobe.io/extensions/EXdd53073348ef467683365286a33ade02"
},
"meta": {
"latest_revision_number": 1
}
}
],
"meta": {
"pagination": {
"current_page": 1,
"next_page": null,
"prev_page": null,
"total_pages": 1,
"total_count": 2
}
}
}
Look up the related extension for a data element extension
You can look up the extension that utilizes a data element by appending /extension to the path of a GET request.
API format
GET /data_elements/{DATA_ELEMENT_ID}/extension
{DATA_ELEMENT_ID}id of the data element whose extension you want to look up.Request
curl -X GET \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/extension \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns the details of the extension that uses the specified data element.
{
"data": {
"id": "EX9c7f9f1e826149978f2dadaf4c639679",
"type": "extensions",
"attributes": {
"created_at": "2020-12-14T17:37:31.952Z",
"deleted_at": null,
"dirty": false,
"enabled": true,
"name": "kessel-test",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:37:31.952Z",
"delegate_descriptor_id": null,
"display_name": "Kessel Test",
"review_status": "unsubmitted",
"version": "1.2.0",
"settings": "{}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/property"
},
"data": {
"id": "PR5c15543ef7bb403abc79d65fee0bf1f9",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/origin"
},
"data": {
"id": "EX9c7f9f1e826149978f2dadaf4c639679",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"extension_package": {
"links": {
"related": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679/extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PR5c15543ef7bb403abc79d65fee0bf1f9",
"origin": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679",
"self": "https://reactor.adobe.io/extensions/EX9c7f9f1e826149978f2dadaf4c639679",
"extension_package": "https://reactor.adobe.io/extension_packages/EP75db2452065b44e2b8a38ca883ce369a",
"latest_extension_package": "https://reactor.adobe.io/extension_packages/EP75db2452065b44e2b8a38ca883ce369a"
},
"meta": {
"latest_revision_number": 1
}
}
}
Look up the related origin for a data element origin
You can look up the origin of a data element by appending /origin to the path of a GET request. The origin of a data element is the previous revision that was updated to create the current revision.
API format
GET /data_elements/{DATA_ELEMENT_ID}/origin
{DATA_ELEMENT_ID}id of the data element whose origin you want to look up.Request
curl -X GET \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/origin \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns the details of the specified data element’s origin.
{
"data": {
"id": "DE790cb76f91594c2082a727b9f97024f6",
"type": "data_elements",
"attributes": {
"created_at": "2020-12-14T17:37:19.891Z",
"deleted_at": null,
"dirty": false,
"enabled": true,
"name": "My Data Element 2020-12-14 17:37:19 +0000",
"published": false,
"published_at": null,
"revision_number": 0,
"updated_at": "2020-12-14T17:37:19.891Z",
"clean_text": false,
"default_value": null,
"delegate_descriptor_id": "kessel-test::dataElements::dom-attribute",
"force_lower_case": false,
"review_status": "unsubmitted",
"storage_duration": null,
"settings": "{\"elementProperty\":\"html\",\"elementSelector\":\".target-element\"}"
},
"relationships": {
"libraries": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/libraries"
}
},
"revisions": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/revisions"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/notes"
}
},
"property": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/property"
},
"data": {
"id": "PRf1ac400fb1e04c689e28d5efcd675c94",
"type": "properties"
}
},
"origin": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/origin"
},
"data": {
"id": "DE790cb76f91594c2082a727b9f97024f6",
"type": "data_elements"
}
},
"extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/extension"
},
"data": {
"id": "EX2345dba2c8b34d1cbe2795e29c62bf27",
"type": "extensions"
}
},
"updated_with_extension_package": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/updated_with_extension_package"
},
"data": {
"id": "EP75db2452065b44e2b8a38ca883ce369a",
"type": "extension_packages"
}
},
"updated_with_extension": {
"links": {
"related": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6/updated_with_extension"
},
"data": {
"id": "EXad7ebb72d721478483b741eebfffda6a",
"type": "extensions"
}
}
},
"links": {
"property": "https://reactor.adobe.io/properties/PRf1ac400fb1e04c689e28d5efcd675c94",
"origin": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6",
"self": "https://reactor.adobe.io/data_elements/DE790cb76f91594c2082a727b9f97024f6",
"extension": "https://reactor.adobe.io/extensions/EX2345dba2c8b34d1cbe2795e29c62bf27"
},
"meta": {
"latest_revision_number": 1
}
}
}
Look up the related property for a data element property
You can look up the property that owns a data element by appending /property to the path of a GET request.
API format
GET /data_elements/{DATA_ELEMENT_ID}/property
{DATA_ELEMENT_ID}id of the data element whose property you want to look up.Request
curl -X GET \
https://reactor.adobe.io/data_elements/DE3fab176ccf8641838b3da59f716fc42b/property \
-H 'Authorization: Bearer {ACCESS_TOKEN}' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {ORG_ID}' \
-H "Content-Type: application/vnd.api+json" \
-H 'Accept: application/vnd.api+json;revision=1'
Response
A successful response returns the details of the property that owns the specified data element.
{
"data": {
"id": "PRae9440b0f3234c4286569485f2b7a6a2",
"type": "properties",
"attributes": {
"created_at": "2020-12-14T17:52:40.829Z",
"enabled": true,
"name": "Kessel Example Property",
"updated_at": "2020-12-14T17:52:40.829Z",
"platform": "web",
"development": false,
"token": "42daac072e1e",
"domains": [
"example.com"
],
"undefined_vars_return_empty": false,
"rule_component_sequencing_enabled": false
},
"relationships": {
"company": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/company"
},
"data": {
"id": "CO2bf094214ffd4785bb4bcf88c952a7c1",
"type": "companies"
}
},
"callbacks": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/callbacks"
}
},
"hosts": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/hosts"
}
},
"environments": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/environments"
}
},
"libraries": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/libraries"
}
},
"data_elements": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/data_elements"
}
},
"extensions": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/extensions"
}
},
"rules": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/rules"
}
},
"notes": {
"links": {
"related": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/notes"
}
}
},
"links": {
"company": "https://reactor.adobe.io/companies/CO2bf094214ffd4785bb4bcf88c952a7c1",
"data_elements": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/data_elements",
"environments": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/environments",
"extensions": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/extensions",
"rules": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2/rules",
"self": "https://reactor.adobe.io/properties/PRae9440b0f3234c4286569485f2b7a6a2"
},
"meta": {
"rights": [
"approve",
"develop",
"manage_environments",
"manage_extensions",
"publish"
]
}
}
}